package cz.muni.fi.pb138.jaro2016.task1;

import java.io.File;
import java.io.IOException;
import java.net.URI;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 * ***********************************************************************
 * Take this skeleton code and implement the missing bodies of
 * <code>averageSalaryInDivision</code> and <code>changePosition</code> methods.
 * Everything else should be left untouched.<br/>
 *
 * After completion, the <code>main</code> method should work correctly.<br/>
 * It reads (parses) the given file (company.xml if you run it directly from the
 * Netbeans project) and processes it using your methods. The company.xml file 
 * is located at <code>src/cz/muni/fi/pb138/jaro2016/task1</code> in 
 * the task project directory.
 * 
 * You can also run a sample calculation using your code of the methods
 * by pressing F6. Then the main method will be executed which produces 
 * the company-out.xml file and store it in the same directory as 
 * the company.xml.
 *
 * General comment: usage of XPath is discouraged in this task. 
 *
 */
public class Main {

    /**
     * W3C object model representation of a XML document. Note: We use the
     * interface(!) not its implementation
     */
    private Document doc;

    /**
     * Task 1, part A: Complete this method. You are likely to consult the Java
     * Core API documentation for org.w3c.dom package when working on this task.
     *
     * Hint for those not experienced in Java: you can use double
     * Double.parseDouble (String s) to convert the text node inside the salary
     * element to a double value.
     *
     * You can suppose that the input document is always valid, i.e. its
     * structure fulfills the criteria specified in the comments inside the
     * document company.xml.
     *
     * @param divisionId to calculate the average salary of all employees 
     * in the division divisionId which must be neither
     * null nor empty (the method need not check it)
     * @returns the average salary of all employees working in this division or -1
     * if there is no person to calculate the salary from
     */
    public double averageSalaryInDivision(String divisionId) {

		// please complete this method
    }

    /**
     * Task 1, part B: Complete this method. The method changes the position of 
     * an existing person identified by an person ID (pid). 
     * If such a person does
     * not exist, the method does nothing.
     *
     * @param pid of the person to add the note to this person. pid must not be
     * null nor empty (the method does not check it)
     * @param position the new position of the person with the given pid
     */
    public void changePosition(String pid, String position) {

		// please complete this method
    }

    /**
     * **********************************************************************
     */
    /**
     * Vytvori novou instanci teto tridy a nacte obsah xml dokumentu se zadanym
     * URL.
     */
    public static Main newInstance(URI uri) throws SAXException,
            ParserConfigurationException, IOException {
        return new Main(uri);
    }

    /**
     * Create a new instance of this class and read the content of the given XML
     * file.
     */
    public static Main newInstance(File file)
            throws SAXException, ParserConfigurationException, IOException {
        return newInstance(file.toURI());
    }

    /**
     * Constructor creating a new instance of Uloha1 class reading from the file
     * at the given URI
     */
    private Main(URI uri) throws SAXException, ParserConfigurationException,
            IOException {
        // Vytvorime instanci tovarni tridy
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        // Pomoci tovarni tridy ziskame instanci DocumentBuilderu
        DocumentBuilder builder = factory.newDocumentBuilder();
        // DocumentBuilder pouzijeme pro zpracovani XML dokumentu
        // a ziskame model dokumentu ve formatu W3C DOM
        doc = builder.parse(uri.toString());
    }

    public void serializetoXML(URI output)
            throws IOException, TransformerConfigurationException, TransformerException {
        // Vytvorime instanci tovarni tridy
        TransformerFactory factory = TransformerFactory.newInstance();
        // Pomoci tovarni tridy ziskame instanci tzv. kopirovaciho transformeru
        Transformer transformer = factory.newTransformer();
        // Vstupem transformace bude dokument v pameti
        DOMSource source = new DOMSource(doc);
        // Vystupem transformace bude vystupni soubor
        StreamResult result = new StreamResult(output.toString());
        // Provedeme transformaci
        transformer.transform(source, result);
    }

    public void serializetoXML(File output) throws IOException,
            TransformerException {
        serializetoXML(output.toURI());
    }

    public static void main(String[] args) throws IOException, SAXException, ParserConfigurationException, TransformerException {

        if (args.length < 1) {
            System.err.println("Input file name is missing.");
            return;
        } else if (args.length < 2) {
            System.err.println("Output file name is missing.");
            return;
        }

        File input = new File(args[0]);
        File output = new File(args[1]);

        Main task1 = newInstance(input);

        // expected outputs are:
        // Average salary in production_zlin is 26500.0
        // Average salary in development_brno is 46515.166666666664
        System.out.println("Average salary in production_zlin is "
                + task1.averageSalaryInDivision("production_zlin"));
        System.out.println("Average salary in development_brno is "
                + task1.averageSalaryInDivision("development_brno"));

        // Expected first few lines of company-out.xml are:
        // <?xml version="1.0" encoding="utf-8" standalone="no"?>
        // <company>
        // <!-- did is required, a string -->
        // <division did="production_zlin">
        //      <!-- name is optional and contains a string -->
        //      <name>Production factory Zlín</name>
        //      <!-- head is optional and contains always a person if present -->
        //      <head position="extra_position_for_1">

        task1.changePosition("1", "extra_position_for_1");

        task1.serializetoXML(output);
    }

    /**
     * Help method for testing purposes.
     */
    Document getDocument() {
        return doc;
    }
}
